commit c72cace9b13a9aba390d84d0a691edf337ed3399
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Tue May 15 14:13:54 2018 +0200

    ref #6913 Remove test specimen import view

diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/dataimport/TestSpecimenImportView.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/dataimport/TestSpecimenImportView.java
deleted file mode 100644
index 980e2a7b2..000000000
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/dataimport/TestSpecimenImportView.java
+++ /dev/null
@@ -1,101 +0,0 @@
-/**
-* Copyright (C) 2017 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.taxeditor.view.dataimport;
-
-import org.eclipse.swt.SWT;
-import org.eclipse.swt.layout.GridData;
-import org.eclipse.swt.layout.GridLayout;
-import org.eclipse.swt.widgets.Button;
-import org.eclipse.swt.widgets.Composite;
-import org.eclipse.swt.widgets.Label;
-import org.eclipse.swt.widgets.List;
-import org.eclipse.swt.widgets.Text;
-import org.eclipse.ui.part.ViewPart;
-
-/**
- * @author k.luther
- * @param <T>
- * @date 02.05.2017
- *
- */
-public class TestSpecimenImportView extends ViewPart {
-    private Text text;
-    private Text text_1;
-    public TestSpecimenImportView() {
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public void createPartControl(Composite parent) {
-
-        Composite composite = new Composite(parent, SWT.NONE);
-        composite.setLayout(new GridLayout(2, true));
-
-        Composite composite_1 = new Composite(composite, SWT.NONE);
-        composite_1.setLayout(new GridLayout(3, false));
-
-        Label lblNewLabel = new Label(composite_1, SWT.NONE);
-        lblNewLabel.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 3, 1));
-        lblNewLabel.setBounds(0, 0, 55, 15);
-        lblNewLabel.setText("Classification");
-
-        text = new Text(composite_1, SWT.BORDER);
-        GridData gd_text = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
-        gd_text.widthHint = 118;
-        text.setLayoutData(gd_text);
-
-        Button btnNewButton = new Button(composite_1, SWT.NONE);
-        GridData gd_btnNewButton = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
-        gd_btnNewButton.widthHint = 36;
-        btnNewButton.setLayoutData(gd_btnNewButton);
-        btnNewButton.setText("New Button");
-
-        Button btnNewButton_1 = new Button(composite_1, SWT.NONE);
-        GridData gd_btnNewButton_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
-        gd_btnNewButton_1.widthHint = 33;
-        btnNewButton_1.setLayoutData(gd_btnNewButton_1);
-        btnNewButton_1.setBounds(0, 0, 75, 25);
-        btnNewButton_1.setText("New Button");
-
-        Label lblNewLabel_1 = new Label(composite_1, SWT.NONE);
-        lblNewLabel_1.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 3, 1));
-        lblNewLabel_1.setBounds(0, 0, 55, 15);
-        lblNewLabel_1.setText("Default import Source Reference Title");
-
-        text_1 = new Text(composite_1, SWT.BORDER);
-        GridData gd_text_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 3, 1);
-        gd_text_1.widthHint = 112;
-        text_1.setLayoutData(gd_text_1);
-        text_1.setBounds(0, 0, 76, 21);
-
-        Button btnNewButton_2 = new Button(composite_1, SWT.NONE);
-        btnNewButton_2.setBounds(0, 0, 75, 25);
-        btnNewButton_2.setText("Configuration");
-        new Label(composite_1, SWT.NONE);
-        new Label(composite_1, SWT.NONE);
-
-        Composite composite_2 = new Composite(composite, SWT.NONE);
-
-        List list = new List(composite_2, SWT.BORDER);
-        list.setBounds(0, 0, 233, 68);
-        // TODO Auto-generated method stub
-
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public void setFocus() {
-        // TODO Auto-generated method stub
-
-    }
-}